           (*-------------------------------------------*
            |                CSP-Prover                 |
            |               February 2005               |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Int_choice_cpo = Int_choice + Domain_SF_prod_cpo:

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare disj_not1 [simp del]

(*  The following simplification is sometimes unexpected.              *)
(*                                                                     *)
(*             not_None_eq: (x ~= None) = (EX y. x = Some y)           *)

declare not_None_eq [simp del]

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  Union (B ` A) = (UN x:A. B x)                      *)
(*                  Inter (B ` A) = (INT x:A. B x)                     *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare Union_image_eq [simp del]
declare Inter_image_eq [simp del]

(*****************************************************************

         1. [[P |~| Q]]T : continuous
         2. [[P |~| Q]]F : continuous
         3. 
         4. 

 *****************************************************************)

(*** Int_choice_evalT_continuous ***)

lemma Int_choice_evalT_continuous:
 "[| continuous [[P]]T ; continuous [[Q]]T |]
  ==> continuous [[P |~| Q]]T"
apply (simp add: continuous_iff)
apply (intro allI impI)
apply (drule_tac x="X" in spec, simp)
apply (drule_tac x="X" in spec, simp)
apply (elim conjE exE)

apply (subgoal_tac "xa = x")
apply (rule_tac x="x" in exI, simp)

apply (subgoal_tac "X ~= {}")
apply (simp add: isLUB_UnionT)
apply (rule eq_iffI)

(* <= *)
 apply (rule)
 apply (simp add: memT_UnionT)
 apply (simp only: Int_choice_mem)
 apply (simp add: memT_UnionT)
 apply (elim bexE disjE)
  apply (rule_tac x="xb" in bexI, simp_all)
  apply (rule_tac x="xb" in bexI, simp_all)

(* => *)
 apply (rule)
 apply (simp add: memT_UnionT)
 apply (simp only: Int_choice_mem)
 apply (simp add: memT_UnionT)
 apply (elim bexE disjE)
  apply (rule disjI1)
  apply (rule_tac x="xb" in bexI, simp_all)
  apply (rule disjI2)
  apply (rule_tac x="xb" in bexI, simp_all)

apply (simp add: directed_def)
by (rule LUB_unique, simp_all)

(*** Int_choice_evalF_continuous ***)

lemma Int_choice_evalF_continuous:
 "[| continuous [[P]]F ; continuous [[Q]]F |]
  ==> continuous [[P |~| Q]]F"
apply (simp add: continuous_iff)
apply (intro allI impI)
apply (drule_tac x="X" in spec, simp)
apply (drule_tac x="X" in spec, simp)
apply (elim conjE exE)

apply (subgoal_tac "xa = x")
apply (rule_tac x="x" in exI, simp)

apply (subgoal_tac "X ~= {}")
apply (simp add: isLUB_UnionF)
apply (rule eq_iffI)

(* <= *)
 apply (rule)
 apply (simp add: Int_choice_mem)
 apply (simp add: memF_UnionF)
 apply (simp add: Int_choice_mem)
 apply (elim conjE bexE disjE)
 apply (rule_tac x="xb" in bexI, simp, simp)
 apply (rule_tac x="xb" in bexI, simp, simp)

(* => *)
 apply (rule)
 apply (simp add: Int_choice_mem)
 apply (simp add: memF_UnionF)
 apply (simp add: Int_choice_mem)
 apply (elim conjE bexE disjE)
 apply (rule disjI1)
 apply (rule_tac x="xb" in bexI, simp, simp)
 apply (rule disjI2)
 apply (rule_tac x="xb" in bexI, simp, simp)

apply (simp add: directed_def)
by (simp add: LUB_unique)

(****************** to add them again ******************)

declare Union_image_eq [simp]
declare Inter_image_eq [simp]
declare disj_not1      [simp]
declare not_None_eq    [simp]

end
