           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |             December 2004 (modified)      |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM02_para = DM01_Sys_def:

(*****************************************************************

         1. expands parallel operators in Sys
         2. step 2
         3. 
         4. 

 *****************************************************************)

(*** Eat0 VAR step 2 ***)

lemma Eat0_VAR: 
  "LET SysDef IN (Eat0 -> <EAT0 n> |[CH0]| <VAR n>)
   =F
   LET SysDef IN ? x:insert Eat0 (insert (RD1 n) (range WR1))
        -> IF (x = Eat0) 
              THEN (<EAT0 n> |[CH0]| <VAR n>)
              ELSE IF (x = RD1 n) 
                   THEN (Eat0 -> <EAT0 n> |[CH0]| <VAR n>)
                   ELSE (Eat0 -> <EAT0 n> |[CH0]| <VAR (getInt x)>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF Eat0_VAR]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF Eat0_VAR[simplified]]

(*** Back0 VAR step 2 ***)

lemma Back0_VAR: 
  "LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR n>)
   =F
   LET SysDef IN ? x:insert Back0 (insert (RD1 n) (range WR1))
        -> IF (x = Back0) 
              THEN (<TH0> |[CH0]| <VAR n>)
              ELSE IF (x = RD1 n)
                   THEN (Back0 -> <TH0> |[CH0]| <VAR n>)
                   ELSE (Back0 -> <TH0> |[CH0]| <VAR (getInt x)>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF Back0_VAR]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF Back0_VAR[simplified]]

(*** Eat0 VAR TH1 step 2 ***)

lemma Eat0_VAR_TH1: 
  "EVEN n ==>
   LET SysDef IN (Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>)
   =F
   LET SysDef IN ? x:{Eat0, RD1 n} 
      -> IF (x = Eat0)
            THEN (<EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>)
            ELSE (Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF Eat0_VAR_TH1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF Eat0_VAR_TH1[simplified]]

(****************************)
(*** Back0 VAR TH1 step 2 ***)

lemma Back0_VAR_TH1: 
  "LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
   =F
   LET SysDef IN ? x:{Back0, RD1 n} 
      -> IF (x = Back0)
            THEN (<TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
            ELSE IF ODD n 
                 THEN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>)
                 ELSE (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (case_tac "EVEN n")
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF Back0_VAR_TH1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF Back0_VAR_TH1[simplified]]

(*** TH0 VAR Eat1 step 2 ***)

lemma TH0_VAR_Eat1: 
  "ODD n ==>
   LET SysDef IN (<TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>)
   =F
   LET SysDef IN ? x:{Eat1, RD0 n} 
      -> IF (x = Eat1)
            THEN (<TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>) 
            ELSE (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF TH0_VAR_Eat1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF TH0_VAR_Eat1[simplified]]

(****************************)
(*** TH0 VAR Back1 step 2 ***)

lemma TH0_VAR_Back1: 
  "LET SysDef IN (<TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
   =F
   LET SysDef IN ? x:{Back1, RD0 n}
      -> IF (x = Back1)
            THEN (<TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
            ELSE IF EVEN n 
                 THEN (Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>) 
                 ELSE (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (case_tac "EVEN n")
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF TH0_VAR_Back1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF TH0_VAR_Back1[simplified]]

end
