           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |             December 2004 (modified)      |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM03_para = DM02_para:

(*****************************************************************

         1. expands parallel operators in Sys
         2.
         3. 
         4. 

 *****************************************************************)

(*** EAT0 VAR step 3 ***)

lemma EAT0_VAR: 
  "LET SysDef IN (<EAT0 n> |[CH0]| <VAR n>)
   =F
   LET SysDef IN ? x:insert End0 (insert (RD1 n) (range WR1))
     -> IF (x = End0) 
           THEN (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n>)
           ELSE IF (x = RD1 n) 
                THEN (<EAT0 n> |[CH0]| <VAR n>)
                ELSE (<EAT0 n> |[CH0]| <VAR (getInt x)>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (case_tac "EVEN n")
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF EAT0_VAR]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF EAT0_VAR[simplified]]

(*** EAT0 VAR TH1 step 3 ***)

lemma EAT0_VAR_TH1: 
  "EVEN n ==>
   LET SysDef IN (<EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>)
   =F
   LET SysDef IN ? x:{End0, RD1 n} 
      -> IF (x = End0)
            THEN (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
            ELSE (<EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF EAT0_VAR_TH1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF EAT0_VAR_TH1[simplified]]

(*** Eat0 VAR Back1 step 3 ***)

lemma Eat0_VAR_Back1:
  "EVEN n ==>
   LET SysDef IN 
        (Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
   =F
   LET SysDef IN ? x:{Eat0, Back1} 
      -> IF (x = Eat0)
            THEN (<EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
            ELSE (Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF Eat0_VAR_Back1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF Eat0_VAR_Back1[simplified]]

(*** TH0 VAR EAT1 step 3 ***)

lemma TH0_VAR_EAT1: 
  "ODD n ==>
   LET SysDef IN (<TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)
   =F
   LET SysDef IN ? x:{End1, RD0 n} 
   -> IF (x = End1)
         THEN (<TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)
         ELSE (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF TH0_VAR_EAT1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF TH0_VAR_EAT1[simplified]]

(*** Back0 VAR Eat1 step 3 ***)

lemma Back0_VAR_Eat1: 
  "ODD n ==>
   LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>)
   =F
   LET SysDef IN ? x:{Eat1, Back0} 
   -> IF (x = Eat1)
         THEN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)
         ELSE (<TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF Back0_VAR_Eat1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF Back0_VAR_Eat1[simplified]]

(*** Back0 VAR Back1 step 3 ***)

lemma Back0_VAR_Back1: 
  "LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
   =F
   LET SysDef IN ? x:{Back0, Back1} 
      -> IF (x = Back0)
            THEN (<TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
            ELSE (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF Back0_VAR_Back1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF Back0_VAR_Back1[simplified]]

end
