           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |             December 2004 (modified)      |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM08_hide = DM07_hide:

(*****************************************************************

         1. expands hiding operators in Sys
         2.
         3. 
         4. 

 *****************************************************************)

(*** TH0 VAR TH1 HIDE step 1 ***)

lemma TH0_VAR_TH1_HIDE:
  "LET SysDef IN
        (<TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
         -- (CH0 Un CH1)
   =F 
   LET SysDef IN
       (IF EVEN n
        THEN ((Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>)
              -- (CH0 Un CH1))
        ELSE ((Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
              -- (CH0 Un CH1)))
        |~|
       (IF ODD n 
        THEN ((<TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>)
              -- (CH0 Un CH1))
        ELSE ((<TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
              -- (CH0 Un CH1)))"
apply (tactic {* csp_simp_add_left_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (rule csp_ref_eq)

 (* <= *)
 apply (rule)
  apply (rule csp_Rep_int_choice_left)
  apply (rule_tac x="RD0 n" in exI)
  apply (case_tac "ODD n")
  apply (simp, tactic {* csp_simp_tac 1 *})+

  apply (rule csp_Rep_int_choice_left)
  apply (rule_tac x="RD1 n" in exI)
  apply (case_tac "ODD n")
  apply (simp, tactic {* csp_simp_tac 1 *})+

(* => *)
 apply (subgoal_tac "{RD0 n, RD1 n} Int (CH0 Un CH1) = {RD0 n, RD1 n}")
 apply (auto)

  apply (rule csp_Int_choice_left1)
  apply (case_tac "ODD n")
  apply (simp, tactic {* csp_simp_tac 1 *})+

  apply (rule csp_Int_choice_left2)
  apply (case_tac "ODD n")
  apply (simp, tactic {* csp_simp_tac 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF TH0_VAR_TH1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF TH0_VAR_TH1_HIDE[simplified]]

(*** WR0 VAR Back1 HIDE ***)

lemma WR0_VAR_Back1_HIDE: 
  "EVEN n ==>
   LET SysDef IN (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        Back1 -> ((WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
                  -- (CH0 Un CH1))
        [>
        (<TH0> |[CH0]| <VAR (n div 2)> |[CH1]| Back1 -> <TH1>)
        -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_left_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (tactic {* csp_light_step_right_tac 1 *})
apply (rule csp_decompo)+
apply (auto)
apply (subgoal_tac "{WR0 (n div 2), Back1} Int (CH0 Un CH1) = {WR0 (n div 2)}")
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})
apply (auto)
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF WR0_VAR_Back1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF WR0_VAR_Back1_HIDE[simplified]]

(*** Back0 VAR WR1 HIDE ***)

lemma Back0_VAR_WR1_HIDE: 
  "ODD n ==>
   LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        Back0 -> ((<TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)
                 -- (CH0 Un CH1))
        [>
        (Back0 -> <TH0> |[CH0]| <VAR (3 * n + 1)> |[CH1]| <TH1>)
        -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_left_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (tactic {* csp_light_step_right_tac 1 *})
apply (rule csp_decompo)+
apply (auto)
apply (subgoal_tac "{WR1 (3 * n + 1), Back0} Int (CH0 Un CH1) = {WR1 (3 * n + 1)}")
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})
apply (auto)
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF Back0_VAR_WR1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF Back0_VAR_WR1_HIDE[simplified]]

(*** WR0 VAR TH1 HIDE ***)

lemma WR0_VAR_TH1_HIDE: 
  "EVEN n ==>
   LET SysDef IN (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
                -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        (<TH0>  |[CH0]| <VAR (n div 2)> |[CH1]| <TH1>)
         -- (CH0 Un CH1)
        |~|
        (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
        -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_left_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (rule csp_ref_eq)

 (* <= *)
 apply (rule)
  apply (rule csp_Rep_int_choice_left)
  apply (rule_tac x="WR0 (n div 2)" in exI)
  apply (simp, tactic {* csp_simp_tac 1 *})+

  apply (rule csp_Rep_int_choice_left)
  apply (rule_tac x="RD1 n" in exI)
  apply (simp, tactic {* csp_simp_tac 1 *})+

(* => *)
 apply (subgoal_tac "{WR0 (n div 2), RD1 n} Int (CH0 Un CH1) ={WR0 (n div 2), RD1 n}")
 apply (auto)

  apply (rule csp_Int_choice_left1)
  apply (tactic {* csp_simp_tac 1 *})+
  apply (rule csp_Int_choice_left2)
  apply (tactic {* csp_simp_tac 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF WR0_VAR_TH1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF WR0_VAR_TH1_HIDE[simplified]]

(*** TH0 VAR WR1 HIDE ***)

lemma TH0_VAR_WR1_HIDE: 
  "ODD n ==>
   LET SysDef IN (<TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)
                  -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        (<TH0> |[CH0]| <VAR (3 * n + 1)> |[CH1]| <TH1>)
        -- (CH0 Un CH1)
        |~|
        (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)
        -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_left_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (rule csp_ref_eq)

 (* <= *)
 apply (rule)
  apply (rule csp_Rep_int_choice_left)
  apply (rule_tac x="WR1 (3 * n + 1)" in exI)
  apply (simp, tactic {* csp_simp_tac 1 *})+
  apply (rule csp_Rep_int_choice_left)
  apply (rule_tac x="RD0 n" in exI)
  apply (simp, tactic {* csp_simp_tac 1 *})+

(* => *)
 apply (subgoal_tac "{WR1 (3 * n + 1), RD0 n} Int (CH0 Un CH1) =
                     {WR1 (3 * n + 1), RD0 n}")
 apply (auto)

  apply (rule csp_Int_choice_left1)
  apply (tactic {* csp_simp_tac 1 *})+
  apply (rule csp_Int_choice_left2)
  apply (tactic {* csp_simp_tac 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF TH0_VAR_WR1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF TH0_VAR_WR1_HIDE[simplified]]

end
